local THIS_RAID = {
    idx = 2,                            -- This index is just for order of appearance in the raid dropdown
    str = 'SiegeOfOrgrimmar',
    display = 'Siege of Orgrimmar',
    bosses = {},
}

local BOSS_ID = {}
local DATA = {}

------------------------------------------------------------------

local function EmptyBoss (id) 
    return {
        idx = id,
        events = {},
        msgs = {},
        init = function () end,
        onevent = function (spellName, event) end,
        onemote = function (sender, msg) end,        
    }
end

local function AddBoss (bossName, bossTable, tblMobs)
    DATA[bossName] = bossTable
    
    if tblMobs then
        for i,v in ipairs(tblMobs) do
            BOSS_ID[v] = bossName
        end
    end
end

------------------------------------------------------------------

local PROTECTORS = {'Rook Stonetoe', 'He Softfoot', 'Sun Tenderheart'}
local GALAKRAS_ALLIES = {'Lady Sylvanas Windrunner', 'Lor\'themar Theron', 'Archmage Aethas Sunreaver', 'King Varian Wrynn', 'Lady Jaina Proudmoore', 'Vereesa Windrunner'}
local DARK_SHAMANS = {'Earthbreaker Haromm', 'Wavebinder Kardris'}
local SPOILS = {'Jun-Wei', 'Zu Yin', 'Xiang-Lin', 'Kun-Da', 'Commander Ik\'tal', 'Commander Na\'kaz', 'Commander Tik', 'Commander Zak\'tar', 'Modified Anima Golem', 'Shadow Ritualist Phylactery', 'Mogu Shadow Ritualist', 'Animated Stone Mogu', 'Burial Urn', 'Zar\'thik Amber Priest', 'Set\'thik Wind Wielder', 'Sri\'thik Bombardier', 'Amber-Encased Kunchong', 'Kor\'thik Warcaller'}
local PARAGONS = {"Kil'ruk the Wind-Reaver", "Xaril the Poisoned Mind", "Kaz'tik the Manipulator", "Korven the Prime", "Iyyokuk the Lucid", "Ka'roz the Locust", "Skeer the Bloodseeker", "Rik'kal the Dissector", "Hisek the Swarmkeeper"}

------------------------------------------------------------------

AddBoss ('Immerseus',               EmptyBoss(1))
AddBoss ('The Fallen Protectors',   EmptyBoss(2), PROTECTORS)
AddBoss ('Norushen',                EmptyBoss(3), {'Amalgam of Corruption'})
AddBoss ('Sha of Pride',            EmptyBoss(4))
AddBoss ('Galakras',                EmptyBoss(5), GALAKRAS_ALLIES)
AddBoss ('Iron Juggernaut',         EmptyBoss(6))
AddBoss ('Kor\'kron Dark Shamans',  EmptyBoss(7), DARK_SHAMANS)
AddBoss ('General Nazgrim',         EmptyBoss(8))
AddBoss ('Malkorok',                EmptyBoss(9))
AddBoss ('Spoils of Pandaria',      EmptyBoss(10), SPOILS)
AddBoss ('Thok the Bloodthirsty',   EmptyBoss(11))
AddBoss ('Siegecrafter Blackfuse',  EmptyBoss(12))
AddBoss ('Paragons of the Klaxxi',  EmptyBoss(13), PARAGONS)
AddBoss ('Garrosh Hellscream',      EmptyBoss(14))

function Raidbot_LoadData_SiegeOfOrgrimmar (bigTable, lstRaids, lstBossId)
    for k,v in pairs(DATA) do
        bigTable[k] = v
        for i,event in pairs(v.events) do
            bigTable[k].msgs[event] = {}
        end
        
        THIS_RAID.bosses[v.idx] = k
    end
    lstRaids[THIS_RAID.idx] = THIS_RAID
    
    for k,v in pairs(BOSS_ID) do
        lstBossId[k] = v
    end
    
    print ('Raidbot: loaded '..THIS_RAID.display)
end
